/**
 * The class parq2d defines the interface for the source code parametrisation.
 *
 * @author Ch. Becker <BR>
 *
 * This module is part of the DeViSoR project
 * by Ch.Becker/C.Waguet
 *
 * @version 0.00.01, 12/16/97
 */

package devisor2.foundation.boundary;

class parq2d 
{

/**
 * returns the x value of a boundary node
 * @param t parameter value
 * @param n number of boundary
 * @return x value
 */
  public native double ParX(double t, int n);


/**
 * returns the y value of a boundary node
 * @param t parameter value
 * @param n number of boundary
 * @return y value
 */
  public native double ParY(double t, int n);


/**
 * returns the maximal parameter value of a boundary
 * @param n number of boundary
 * @return parameter value
 */
  public native double Tmax(int n);


/**
 * creates a new link to the source code parametrisation
 * located in the file name.f in FEAT format
 * @param name file name
 */
  parq2d(String name) 
  {		
    System.load(name);
  }

}
