package devisor2.grid.GUI.dialogs;

import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;

import java.util.*;

import devisor2.grid.options.*;

/**
 *  The ListSelectionListener class to detect changes in the table
 *  on the Accelerators Tab in OptionsDialog class
 *
 *  @author Dominik Goeddeke
 *  @version 1.0 (fully tested)
 */
class AcceleratorTableListSelectionListener implements ListSelectionListener
{
    /**
     *  reference to the OptionsDialog where the JTable is located
     */
    private OptionsDialog parent;

    /**
     *  the constructor just sets references correctly
     *
     *  @param parent - an OptionsDialog reference
     */
    public AcceleratorTableListSelectionListener (OptionsDialog parent)
    {
	super ();
	this.parent = parent;
    }

    /**
     *  updates the parent reference
     *
     *  @parent - the new Optionsdialog reference
     */
    public void setParent (OptionsDialog parent)
    {
	this.parent = parent;
    }

    /**
     *  the overridden method declared in the interface
     */
    public void valueChanged (ListSelectionEvent e)
    {
	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
	if (e.getValueIsAdjusting() && (!(lsm.isSelectionEmpty()))) 
	    return;
	else
	{
	    int selectedRow = parent.getAcceleratorTable().getSelectedRow();
	    if (selectedRow != -1)
	    {
		Vector data = parent.getAcceleratorTableData();
		Object o = data.elementAt(selectedRow);
		String[] pair = (String[])o;
		String accString = pair[1];
		// set radiobuttons
		int posplus = accString.indexOf ('+');
		if (posplus != -1)
		{
		    if (accString.substring(0,posplus).equals("CTRL"))
			parent.getCTRLbutton().doClick();
		    else
		    {
			if (accString.substring(0,posplus).equals("ALT"))
			    parent.getALTbutton().doClick();
			else
			{
			    if (accString.substring(0,posplus).equals("SHIFT"))
				parent.getSHIFTbutton().doClick();
			}
		    }
		}
		else
		{
		    parent.getNONEbutton().doClick();
		}
		//set ComboBox
		parent.getKeySelectionComboBox ().setSelectedItem (accString.substring(posplus+1,accString.length()));
	    }
	}
    }
}
