package devisor2.grid.GUI.framework;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


import devisor2.grid.options.*;


/** 
 *  This is the status bar for the MainFrame. <br>
 *  The only important method is the one called display(), which displays
 *  a given String centered in the staturbar. So, nothing really spectacular
 *  here, just a convenience class. <br>
 *  Note: The status bar extends the JPanel class, so it can be included
 *  into the MainFrame's layout with just a single line of code. <br>
 *  <br>
 *  To display something from within the application, get a reference to the
 *  MainFrame instance, then use the MainFrame's getStatusBar() method
 *  to call the display() method. That's it.
 * 
 *
 *  @author Dominik Goeddeke
 *  @version 1.0 (fully tested)
 */

public class StatusBar extends JPanel 
{
    /**
     *  The label which holds the text to be displayed
     */
    private JLabel label;

    /**
     *  The usual control center reference
     */
    private ControlCenter cc;
    
    /**
     *  the constructor just creates the gui, sets references correctly
     *  
     */
    public StatusBar ()
    {
	super();
	cc = ControlCenter.getMyself ();
	label = new JLabel();
	setBorder(BorderFactory.createLineBorder(Color.black));
	add (label);
    }

    /**
     *  displays the given text in the statusbar.
     *
     *  @param text - the text to be displayed
     */
    public void display (String text)
    {
	label.setText (text);
	validate ();
	repaint ();
    }

  
}
