package devisor2.grid.GUI.help;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;
import java.awt.*;
import java.awt.event.*;

import java.net.*;
import java.io.*;

import devisor2.grid.options.*;

/** 
 *  This class is just a simple container to display the online version of
 *  the FAQ (which will be created by the tex2html tool. <br>
 *
 * @author Dominik Goeddeke (based on an implementation by Matthias Moeller)
 * @version 0.9
 */
public class FAQFrame extends JFrame 
{
    /**
     *  reference to the ControlCenter
     */
    private ControlCenter cc;

    /** 
     *  the Constructor just initialises a new FAQFrame and connects it
     *  to the html file of the manual
     *
     *  @param String filename the absolut path (or relative path from 
     *                         devisorhome) to the html file
     *  @throws IOException if the specified file could not be loaded properly
     */
    public FAQFrame(String filename) 
	throws IOException
    {
	// general stuff as usual
	cc = ControlCenter.getMyself ();
	// lay out GUI elements
	initComponents ();
	// Add HTML-file to be displayed
	jEditorPane1.setEditorKit(new HTMLEditorKit());
	jEditorPane1.setPage(filename);
	jEditorPane1.setBackground(Color.white);
	jEditorPane1.setForeground(Color.black);
	jEditorPane1.addHyperlinkListener(createHyperLinkListener());
	// all done
	pack ();
    }

    /**
     *  lays out GUI elements 
     */
    private void initComponents () 
    {
	jPanel1 = new JPanel ();
	jButton1 = new JButton ();
	jScrollPane1 = new JScrollPane ();
	jEditorPane1 = new JEditorPane ();
	setTitle ((String)cc.rb.getObject("GUI_help_FAQFrame_frametitle"));
	jButton1.setText ((String)cc.rb.getObject("general_Ok"));
	jButton1.addActionListener (new java.awt.event.ActionListener () {
		public void actionPerformed (java.awt.event.ActionEvent evt) {
		    exitFrame ();
		}
	    });
	
	jPanel1.add (jButton1);
	
	getContentPane ().add (jPanel1, java.awt.BorderLayout.SOUTH);
	
	jEditorPane1.setContentType ("text/html");
	jEditorPane1.setEditable(false);
	jEditorPane1.setFont (new Font ("Default", 0, 12));
	
	jScrollPane1.setViewportView (jEditorPane1);
	
	getContentPane ().add (jScrollPane1, java.awt.BorderLayout.CENTER);
    }

    /**
     *  just hides the frame
     */
    private void exitFrame() 
    {
	this.hide();
    }
    
    // attributes for quick reference to  GUI elements
    private JPanel jPanel1;
    private JButton jButton1;
    private JScrollPane jScrollPane1;
    private JEditorPane jEditorPane1;
    
    public HyperlinkListener createHyperLinkListener() 
    {
	return new HyperlinkListener() 
	    {
		public void hyperlinkUpdate(HyperlinkEvent e) 
		{
		    if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
			if (e instanceof HTMLFrameHyperlinkEvent) {
			    ((HTMLDocument)jEditorPane1.getDocument()).processHTMLFrameHyperlinkEvent((HTMLFrameHyperlinkEvent)e);
			} 
			else 
			{
			    try 
			    {
				jEditorPane1.setPage(e.getURL());
			    } 
			    catch (java.io.IOException ioe) 
			    {
				JOptionPane.showMessageDialog(null,ioe.getMessage(),(String)cc.rb.getObject("errors_messageboxheader"),JOptionPane.ERROR_MESSAGE);
			    }
			}
		    }
		}
	    };
    }
}


