package devisor2.grid.backend;


import java.awt.*;
import java.awt.geom.*;

import devisor2.grid.options.*;

/**
 *  Due to some unsolvable problem applying affine transformations
 *  to circles, we decided to create our own Transformation class.
 *  It basically holds an attribute of type AffineTransform (a matrix
 *  representing the transformation in homogenous coordinates)
 *  and additionally all transformation parameters.
 *  Note: all parameters are measured in WORLD COORDINATES!
 *
 * @author Dominik Goeddeke
 *
 */
public class GridTransformation
{

    private AffineTransform matrix;

    private double angle;

    private double scaleX;
    private double scaleY;

    private int translateX;

    private int translateY;

    private int anchorX;
    private int anchorY;

    /**
     *  sets all attributes to the given parameters
     */
    public GridTransformation (AffineTransform matrix, double angle, double scaleX, double scaleY, int translateX, int translateY, int anchorX, int anchorY)
    {
	this.matrix = matrix;
	this.angle = angle;
	this.scaleX = scaleX;
	this.scaleY = scaleY;
	this.translateX = translateX;
	this.translateY = translateY;
	this.anchorX = anchorX;
	this.anchorY = anchorY;
    }

    public AffineTransform getMatrix ()
    {
	return matrix;
    }

    public double getAngle ()
    {
	return angle;
    }

    public double getScaleX()
    {
	return scaleX;
    }

    public double getScaleY()
    {
	return scaleY;
    }

    public int getTranslateX ()
    {
	return translateX;
    }

    public int getTranslateY ()
    {
	return translateY;
    }

    public int getAnchorX ()
    {
	return anchorX;
    }

    public int getAnchorY ()
    {
	return anchorY;
    }


}
