package devisor2.grid.backend.spellchecker;

import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;

import java.util.*;

import devisor2.grid.options.*;
import devisor2.foundation.*;
import devisor2.foundation.elements.*;
import devisor2.foundation.boundary.*;
import devisor2.foundation.base.*;

/**
 *  The ListSelectionListener class to detect changes in the table
 *
 *  @author Dominik Goeddeke
 *  @version 1.0 (fully tested)
 */
class SpellCheckerTableListSelectionListener implements ListSelectionListener
{
    /**
     *  reference to the SpellCheckerDialog where the JTable is located
     */
    private SpellCheckerDialog parent;

    private ControlCenter cc;

    /**
     *  the constructor just sets references correctly
     *
     *  @param parent - an OptionsDialog reference
     */
    public SpellCheckerTableListSelectionListener (SpellCheckerDialog parent)
    {
	super ();
	this.parent = parent;
	this.cc = ControlCenter.getMyself ();
    }

    /**
     *  updates the parent reference
     *
     *  @parent - the new SpellCheckerDialog reference
     */
    public void setParent (SpellCheckerDialog parent)
    {
	this.parent = parent;
    }

    /**
     *  the overridden method declared in the interface
     */
    public void valueChanged (ListSelectionEvent e)
    {
	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
	GridItem item = null;
	if (e.getValueIsAdjusting() && (!(lsm.isSelectionEmpty())))
	{
	    item = null;
	}
	else
	{
  	    int selectedRow = parent.getTable().getSelectedRow();
	    if (selectedRow != -1)
  	    {
  		Vector data = parent.getTableData ();
  		Object o = data.elementAt(selectedRow);
  		String[] pair = (String[])o;
  		String type = pair[0];
		int number = Integer.parseInt (pair[1])-1;
		if (type.equals (cc.wS("spellchecker_tablemodel_isolatednode")))
		{
		    item = cc.d.getNode (number);
		}
		if (type.equals (cc.wS("spellchecker_tablemodel_innerangle")))
		{
		    item = cc.d.getCell (number);
		}
		if (type.equals (cc.wS("spellchecker_tablemodel_aspectratio")))
		{
		    item = cc.d.getCell (number);
		}
		if (type.equals (cc.wS("spellchecker_tablemodel_neighbours")))
		{
		    item = cc.d.getCell (number);
		}
  	    }
  	}
	parent.setSelectedItem (item);
    }
}
